#include <cstdio>
#include <map>
#include <string>
#include <algorithm>
#include <vector>
#include <cstring>
using namespace std;

/*class wym {
  int a, b;
  wym(int a1, int b1)
};*/

//typedef long double wym;

int nwd(long long int a, long long int b) {
  if ((a<0))
    return nwd(-a,b);
  if ((b<0))
    return nwd(a,-b);
  if (a == 0)
    return b;
  return nwd(b % a, a);
}

struct wym {
  int a, b;
  wym() {}
  wym(long long int a1, int b1) { /*if (!b1) exit(1);*/ long long int d = nwd(a1, b1); a = a1/d; b = b1/d; }
  wym operator*(const wym& w2) { return wym(a*w2.a, b*w2.b); }
  wym operator-(const wym& w2) { /*if (a*w2.b-b*w2.a<0) exit(1);*/ return wym(abs(a*w2.b-b*w2.a), b*w2.b); };
  bool nz() { return a != 0; }
  wym odw() { return wym(b, a); }
};

bool operator<(const wym& w1, const wym& w2) { return w1.a*w2.b < w2.a*w1.b; }
bool operator<=(const wym& w1, const wym& w2) { return w1.a*w2.b <= w2.a*w1.b; }

map<string, int> numer;
wym przel[10][10];
int num;
char jjedn[10][20];

struct wzorzec {
  int il, jj;
  wym wart;
  wzorzec(int il1, int jj1) { il = il1; jj = jj1; wart = wym(il,1)*przel[jj][1]; }
};

bool operator<(const wzorzec& w1, const wzorzec& w2) {
  return w1.wart < w2.wart;
}

vector<wzorzec> wz;

int jedn(const string& s) {
  int nn = numer[s];
  if (!nn) {
    nn = numer[s] = ++num;
    strcpy(jjedn[nn], s.c_str());
    przel[nn][nn] = wym(1,1);
  }
  return nn;
}

void dodaj(int j1, int j2, wym w) {
  if ((j1 == j2) || (przel[j1][j2].nz()))
    return;
  przel[j1][j2] = w;
  przel[j2][j1] = w.odw();
  for (int jj = 1; jj <= num; jj++)
    if (przel[j2][jj].nz())
      dodaj(j1, jj, w*przel[j2][jj]);
  for (int jj = 1; jj <= num; jj++)
    if (przel[jj][j1].nz())
      dodaj(jj, j2, przel[jj][j1]*w);
}

/*inline wym ABS(wym x) {
  return x >= 0.0 ? x : -x;
}*/

void wypisz(wym w) {
  printf("%d/%d", w.a, w.b);
}

int szukaj(wym w) {
  if (w < wz[0].wart)
    return 0;
  int a = 0;
  int b = wz.size();
  while (a + 1 < b) {
    int s = (a + b) / 2;
    if (wz[s].wart <= w)
      a = s;
    else
      b = s;
  }
/*  if (b < wz.size()) {
  printf("porownuje ");
  wypisz(wz[b].wart - w);
  printf(" ");
  wypisz(w - wz[a].wart);
  printf("\n");
  }*/
//  if (wz[b].wart < w) exit(1);
//  if (w < wz[a].wart) exit(1);
  while ((b < wz.size()) && (wz[b].wart < w))
    b++;
  if ((b < wz.size()) && ((wz[b].wart - w) < (w - wz[a].wart))) {
//    printf("porownalem %llf < %llf\n", ABS(wz[b].wart - w), ABS(wz[a].wart - w));
    a = b;
  }
  return a;
}

int main() {
  int zzz;
  scanf("%d", &zzz);
  for (int zz = 0; zz < zzz; zz++) {
    int p;
    scanf("%d", &p);
    numer.clear();
    num = 0;
    for (int aa = 0; aa < 10; aa++)
      for (int bb = 0; bb < 10; bb++)
        przel[aa][bb] = wym(0,1);
    for (int i = 0; i < p; i++) {
      char j1[15], j2[15];
      int w;
      char ddd[15], eee[15];
      scanf("%s %s %s %d %s", ddd, j1, eee, &w, j2);
      int jj1 = jedn(j1);
      int jj2 = jedn(j2);
      dodaj(jj1, jj2, wym(w,1));
    }
    int ww;
    scanf("%d", &ww);
    wz.clear();
    for (int i = 0; i < ww; i++) {
      int il;
      char j[15];
      scanf("%d %s", &il, &j);
      wz.push_back(wzorzec(il, jedn(j)));
//      printf("aa %d %s %llf\n", wz[i].il, jjedn[wz[i].jj], wz[i].wart);
    }
    sort(wz.begin(), wz.end());
    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; i++) {
      int il;
      char j[15];
      scanf("%d %s", &il, &j);
      wym wart = wym(il,1) * przel[jedn(j)][1];
      int sz = szukaj(wart);
//      printf("sz: %d\n", sz);
      printf("%d %s\n", wz[sz].il, jjedn[wz[sz].jj]/*, wz[i].wart*/);
    }
  }
}
