#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);++i)
#define FOR(i,a,b) for(int i=(a);i<=(b);++i)
#define FORE(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define MP make_pair
#define PB push_back
#define PI pair<int,int>

const int S=50010,SM=1000010,INF=2000000000;
int Ta;
vector<PI> adj[S];
int n,m,w[SM],t[SM],a[SM],l[SM],d[S],u,v;

int main() {
    scanf("%d",&Ta);
    REP(Te,Ta) {
	scanf("%d%d",&n,&m);
	REP(i,n) adj[i].clear();
	REP(i,m) { scanf("%d%d%d%d%d%d",&u,&v,&w[i],&t[i],&a[i],&l[i]);
	    --u; --v; adj[u].PB(MP(v,i));
	}
	REP(i,n) d[i]=INF;
	priority_queue<PI,vector<PI>,greater<PI> > q;
	q.push(MP(d[0]=0,0));
	while (!q.empty()) {
	    int v=q.top().second, dist=q.top().first; q.pop();
	    if (dist > d[v]) continue;
	    FORE(i,adj[v]) {
		int u=i->first, e=i->second;
		int dd=w[e]+dist, czek=0;
		if (a[e]!=0 || t[e]!=0 || l[e]!=0) {
		    int T=(dist-a[e]+t[e])%t[e];
		    if (T>=l[e]) czek=t[e]-T;
		    dd+=czek;
		}
		if (dd<d[u]) q.push(MP(d[u]=dd,u));
	    }
	}
	if (d[n-1]==INF) printf("NIE\n"); else
	printf("%d\n",d[n-1]);
    }
    return 0;
}
